{ 
  open Parse
}

let delim = "%"
let word = ['a'-'z''A'-'Z'] ['a'-'z''A'-'Z''0'-'9']*
let number = ['0'-'9']+
let punct = ['.' ',' '?' ';']
let ws = ['\n' '\t' ' ']+
let blank = [' ']+

rule token = parse
  | '(' { (*Printf.printf "LBRACKET\n"; *)LBRACKET }
  | ')' { (*Printf.printf "RBRACKET\n"; *)RBRACKET }
  | '{' { (*Printf.printf "LBRACE\n"; *)LBRACE }
  | ('}' | ws)+ { (*Printf.printf "RBRACE\n";*) RBRACE }
  | 'x' { (*Printf.printf "XDEG\n"; *)XDEG }
  | 'y' { (*Printf.printf "YDEG\n"; *)YDEG }
  | 'z' { (*Printf.printf "ZDEG\n"; *)ZDEG }
  | ('t' | ws)+ {(* Printf.printf "TRANS\n"; *)TRANS }
  | ('r' | ws)+ { (*Printf.printf "ROT\n"; *)ROT }
  | ('s' | ws)+ {(* Printf.printf "SCALE\n"; *)SCALE }
  | ('c' | ws)+ { (*Printf.printf "COLOR\n"; *)COLOR }
  | '*' {(* Printf.printf "TIMES\n"; *)TIMES }
  | '+' { (*Printf.printf "ADD\n"; *)ADD }
  | '-' {(* Printf.printf "MINUS\n"; *)MINUS }
  | '[' {(* Printf.printf "LHOOK\n"; *)LHOOK }
  | ']' {(* Printf.printf "RHOOK\n"; *)RHOOK }
  | blank {(* Printf.printf "BLANK\n"; *)BLANK }
  | number as num { (*Printf.printf "COEFF\n"; *)COEFF (float_of_string num) }
  | '-'number as num { (*Printf.printf "COEFF\n"; *)COEFF (float_of_string num) }
  | (number '.' number) as num { (*Printf.printf "COEFF\n"; *)COEFF (float_of_string num) }
  | ('-' number '.' number) as num { (*Printf.printf "COEFF\n"; *)COEFF (float_of_string num) }
  | punct { (*Printf.printf "PUNCT\n"; *)PUNC}
  | (word | ws)+ as str {(*Printf.printf "EQUATION\n";*) EQUATION (str) }
  | eof          {EOF}
  | _ {failwith((Lexing.lexeme lexbuf) ^ 
       ": mistake")}
{
}