%token BLANK
%token LBRACKET RBRACKET
%token LBRACE RBRACE
%token LHOOK RHOOK
%token EOF DELIMITER PUNC
%token XDEG YDEG ZDEG
%token TRANS ROT SCALE COLOR
%token TIMES ADD MINUS
%token <string> EQUATION
%token <float> COEFF

%start main
%type <float array array array array> main
%%

main:
| equation main { Array.append [| $1 |] $2}
| EOF {[||]};

equation:
| EQUATION LBRACE termes RBRACE { [| $3 |] }
| EQUATION LBRACE termes RBRACE LHOOK param RHOOK { [| $3 ; $6 |] }

param:
| params { [| $1 ; [| |] ; [|  |] ; [|  |] |] }
| params PUNC params { [| $1 ; $3 ; [|  |] ; [|  |] |] }
| params PUNC params PUNC params { [| $1 ; $3 ; $5 ; [|  |] |] }
| params PUNC params PUNC params PUNC params { [| $1 ; $3 ; $5 ; $7 |] }
| { [| [|  |] ; [|  |] ; [|  |] ; [|  |] |] }

params:
| ROT COEFF PUNC COEFF PUNC COEFF { [| 1. ; $2 ; $4 ; $6 |] }
| TRANS COEFF PUNC COEFF PUNC COEFF { [| 2. ; $2 ; $4 ; $6 |] }
| COLOR COEFF PUNC COEFF PUNC COEFF { [| 3. ; $2 ; $4 ; $6 |] }
| SCALE COEFF PUNC COEFF PUNC COEFF { [| 4. ; $2 ; $4 ; $6 |] }

termes:
| terme ADD termes { Array.append [| $1 |] $3 }
| terme { [| $1 |] }

terme:
| rcoeff rxdeg rydeg rzdeg { [| $2 ; $3 ; $4 ; $1 |] }

rxdeg:
| XDEG TIMES rxdeg { 1. +. $3 }
| XDEG { 1. }
| { 0. }

rydeg:
| YDEG TIMES rydeg { 1. +. $3 }
| YDEG { 1. }
| { 0. }

rzdeg:
| ZDEG TIMES rzdeg { 1. +. $3 }
| ZDEG { 1. }
| { 0. }

rcoeff:
| LBRACKET COEFF RBRACKET TIMES { $2 }
| LBRACKET COEFF RBRACKET { $2 }
| { 1. }